#!/usr/bin/python
# -*- coding: utf-8 -*-
###
#This file is part of <name prog> project
#
#<описание программы>
#Copyright (C) <year> <name|nick>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#You can contact author by email <my email>
###
import os
import sys
import tempfile
import subprocess
import re
from copy import copy
from hashlib import sha256

NAME = "pyaudiocheck"
VERSION = "0.0.1a"

SCRIPT_DIR = os.path.dirname(os.path.abspath(__file__))
AUDIOCHECK_BIN = os.path.join( SCRIPT_DIR, "bin", "auCDtect")
DEVNULL = open(os.devnull,'w')
class UnpackToWav:
    file_formats = {
            'flac':['flac','-d']
            }
    def __init__(self):
        pass
    def issupport(self, filepath):
        '''docstring for issupport'''
        in_name, in_ext = os.path.splitext(filepath)
        return not not self.file_formats.get( in_ext[1:] )
    def unpack_to_wav(self, in_path, out_path=''):
        in_name, in_ext = os.path.splitext(in_path)
        if not out_path:
            out_path = tempfile.mktemp(suffix='.wav')
        if in_ext:
            _args = copy(self.file_formats.get( in_ext[1:] ))
            if _args:
                _args.extend( [ os.path.abspath(in_path), '-o', out_path ] )
                opn = subprocess.Popen( _args, stdout=DEVNULL, stderr=DEVNULL )
                return out_path



class AudioCheck:
    result_pattern = re.compile(
            r'This track looks like (?P<codec>[A-Z]{2,5}) with probability (?P<per>[\d]{1,3})%'
            )
    files = []
    summary = 0
#    file_item = { "name":None, "path": None, "result": {"codec":None,"per":None} }
    def __init__(self):
        self.unpacker = UnpackToWav()
    def test(self, file_path):
        args = [ AUDIOCHECK_BIN, file_path , "-m5"]
#        opn = os.popen( " ".join(args))
        opn = subprocess.Popen( args, stdout = subprocess.PIPE, stderr=DEVNULL )
        result = opn.communicate()[0]
        os.remove(file_path)
        match = self.result_pattern.search( result)
        if match:
            return match.groupdict()
        else:
            return False
    def testing(self):
        '''docstring for testing'''
        _summary = []
        for file_item in self.files:
            tmp = self.unpacker.unpack_to_wav( file_item["path"] )
            result = self.test(tmp)
            file_item["result"] = result
            if result:
                _summary.append( int(result["per"]) )
        self.summary = sum(_summary)/float(len(_summary))


    def load(self, path=os.path.curdir):
        if os.path.isdir( path):
            for f in os.listdir( path):
                if self.unpacker.issupport( f):
                    self.files.append( {"name": f, "path":os.path.join( path, f) } )
        elif os.path.isfile( path):
            if self.unpacker.issupport( path):
                self.files.append( {"name": os.path.split(f)[1], "path": path } )
    def make_log(self):
        out_log = []
        out_log.append( "%s %s by Apkawa <apkawa@gmail.com>"%(NAME, VERSION) )
        out_log.append( "~"*23 )
        out_log.append( "~ Do not edit this file. ~" )
        out_log.append( "" )
        i = 1
        for file_item in sorted(self.files):
            result = file_item["result"]
            if result:
                out_log.append( "%.2i -_- %s _-_ %s %s%%"%(i,
                    file_item["name"], result["codec"], result["per"] ) )
            else:
                out_log.append( "%.2i -_- %s _-_ ERROR"%(i,
                    file_item["name"] ))

        out_log.append( "" )
        out_log.append( "Summary: %.2f"%self.summary )
        out_log.append( "~"*23 )
        str_out_log = "\n".join( out_log )
        str_out_log += "\nsha256 log hash: %s%%"%sha256(str_out_log).hexdigest()
        return str_out_log







def  main( *args, **kwargs):
    """
    main()
    """
    auc = AudioCheck()
    auc.load()
    auc.testing()
    print auc.make_log()


if __name__ == "__main__":
    main()
